Index: /trunk/gsdl/macros/about.dm
===================================================================
--- /trunk/gsdl/macros/about.dm	(revision 643)
+++ /trunk/gsdl/macros/about.dm	(revision 644)
@@ -14,18 +14,24 @@
 #######################################################################
 
-_Global:aboutextra_ {
-_collectionextra_
+_texthelpexpl_ {For help at any time, press this button at the top of the page}
 
-<h3>How to find information</h3>
+_textretabout_ {To return to this "about" page, click the "collection"
+icon at the top left of the page.}
 
-<p>
-<table cellpadding=3 cellspacing=0 border=0>
-<tr valign=top><td><img src="_httpiconchelpon_" width=_widthchelpx_ height=_heightchelpx_></td>
-<td><i>For help at any time, press this button at the top of the page</i>
-</td></tr></table>
+_textabcol_ {About this collection}
 
-_help:simplehelp_
+_textabout_ {
+<h3>_textabcol_</h3>
+_Global:collectionextra_
 }
 
+#######################################################################
+# Maori language text 
+#######################################################################
+
+_texthelpexpl_ [l=mi] {Kia titiro ki ng&auml; kupu &auml;whina p&auml;whiritia t&euml;nei
+p&auml;tene kei runga r&auml; o te wh&auml;rangi}
+
+_textabcol_ [l=mi] {He kupu whakam&auml;rama i te kohikohinga niupepa}
 
 ##############
@@ -42,4 +48,14 @@
 <p>
 _iconblankbar_<br>
-_aboutextra_
+<i>_textretabout_</i>
+<table cellpadding=3 cellspacing=0 border=0>
+<tr valign=bottom><td><img src="_httpiconchelpon_" width=_widthchelpx_ height=_heightchelpx_></td>
+<td><i>_texthelpexpl_</i>
+</td></tr></table>
+_iconblankbar_
+<p>
+_textabout_
+<h3>_help:textsimplehelpheading_</h3>
+_help:simplehelp_
 }
+
Index: /trunk/gsdl/macros/base.dm
===================================================================
--- /trunk/gsdl/macros/base.dm	(revision 643)
+++ /trunk/gsdl/macros/base.dm	(revision 644)
@@ -5,4 +5,15 @@
 package Global
 
+##########
+
+# this is a hack for the chinese collection and should be removed once 
+# the collection metadata is fixed up 
+_documents_ [c=chinese] {document sections}
+_documents_ [c=chinese,l=zh] {ææ¬}
+_titles_ [c=chinese] {titles}
+_titles_ [c=chinese,l=zh] {é¢å}
+_chinese_ {Chinese demonstration collection}
+
+##########
 
 _collectionextra_ {This collection contains _about:numdocs_ documents. 
@@ -533,5 +544,7 @@
 
 _httpiconhabout_ {_httpimg_/h\_about.gif}
+_httpiconhabout_ [l=mi] {_httpimg_/mh\_about.gif}
 _widthhabout_ {200}
+_widthhabout_ [l=mi] {262}
 _heighthabout_ {57}
 
@@ -814,5 +827,5 @@
 _textimagebrowsedates_ [l=mi] {Tirohia te w&auml; i puta mai ai ng&auml; niupepa}
 
-_page_ [l=mi] {wh&auml;rangi}
+_page_ [l=mi] {wh&auml;rangi }
 _vol_ [l=mi] {Pukapuka}
 _num_ [l=mi] {Nama}
@@ -829,5 +842,5 @@
 _textmonth11_ [l=mi] {Noema}
 _textmonth12_ [l=mi] {Tihema}
-_of_ [l=mi] {i te}
+_of_ [l=mi] { i te }
 
 
@@ -838,2 +851,5 @@
 _texticonprev_ [l=mi] {titiro ki te wh&auml;rangi o mua}
 _texticontext_ [l=mi] {Tirohia te wh&auml;rangi}
+
+_textimageSeries_ [l=mi] {Tirohia te whakar&auml;rangi taitara}
+_textimageDate_ [l=mi] {Tirohia te whakar&auml;rangi w&auml;taka}
Index: /trunk/gsdl/macros/document.dm
===================================================================
--- /trunk/gsdl/macros/document.dm	(revision 643)
+++ /trunk/gsdl/macros/document.dm	(revision 644)
@@ -392,11 +392,17 @@
 
 _httpiconehlof_ {_httpimg_/ehlof.gif}
+_httpiconehlof_ [l=mi] {_httpimg_/mehlof.gif}
 _httpiconehlon_ {_httpimg_/ehlon.gif}
+_httpiconehlon_ [l=mi] {_httpimg_/mehlon.gif}
 _widthehlx_ {53}
+_widthehlx_ [l=mi] {47}
 _heightehlx_ {30}
 
 _httpiconenhlof_ {_httpimg_/enhlof.gif}
+_httpiconenhlof_ [l=mi] {_httpimg_/menhlof.gif}
 _httpiconenhlon_ {_httpimg_/enhlon.gif}
+_httpiconenhlon_ [l=mi] {_httpimg_/menhlon.gif}
 _widthenhlx_ {57}
+_widthenhlx_ [l=mi] {56}
 _heightenhlx_ {30}
 
@@ -495,2 +501,6 @@
 _texticonopenbook_ [l=mi] {k&auml;tia}
 _texticonpointer_ [l=mi] {w&auml;hanga e tiro ana}
+_texticonhighlight_ [l=mi] {Kia p&uuml;kaha ng&auml; kupu rapu}
+_texticonnohighlight_ [l=mi] {Kia kore he p&uuml;kaha}
+_texticonsmalltext_ [l=mi] {He wh&auml;rangi niupepa}
+_texticonclosedfolder_ [l=mi] {He k&ouml;paki}
Index: /trunk/gsdl/macros/help.dm
===================================================================
--- /trunk/gsdl/macros/help.dm	(revision 643)
+++ /trunk/gsdl/macros/help.dm	(revision 644)
@@ -5,12 +5,4 @@
 _iconthispage_ [l=mi] {<img src="_httpimg_/mh_help.gif" alt="&Auml;whina" width="200" height="57">}
 
-
-_textnumbrowseoptions_ {<p>There _If_("_numbrowseoptions_" == "1",is 1 way,are _numbrowseoptions_ ways) to 
-find information in this collection:}
-
-_textnumbrowseoptions_ [l=mi] {<p>E _numbrowseoptions_ ng&auml; huarahi hei rapu k&ouml;rero i te kohikohinga niupepa}
-
-_textsimplehelpheading_ {<h2>How to find information</h2>}
-_textsimplehelpheading_ [l=mi] {<h2>Ng&auml; huarahi hei rapu k&ouml;rero</h2>}
 
 _simplehelp_ {
@@ -44,7 +36,6 @@
 _textSearchlong_ [l=mi] {
 <p>Ko te wh&auml;rangi rapu te wh&auml;rangi <i>e rapu atu ai ng&auml; kupu</i> i roto
-i ng&auml; tuhinga. Koia nei te wh&auml;rangi ka puta mai ai i te tuatahi. Kia puta
-mai ai t&euml;nei wh&auml;rangi, i a koe e titiro ana ki wh&auml;rangi k&euml;,
-p&auml;whiritia te p&auml;tene <i>rapu</i>.
+i ng&auml; tuhinga. Kia puta mai ai t&euml;nei wh&auml;rangi, i a koe e titiro ana ki 
+te kohinga niupepa nei p&auml;whiritia te p&auml;tene <i>rapu</i>.
 }
 
@@ -153,5 +144,5 @@
 <a name=finding-information>
 _iconblankbar_<br>
-_textsimplehelpheading_
+<h2>_textsimplehelpheading_</h2>
 _simplehelp_
 <p>
@@ -175,5 +166,5 @@
 <h2 align=left>Topics</h2>
 <ul>
-  <li><a href="\#finding-information">How to find information</a>
+  <li><a href="\#finding-information">_textsimplehelpheading_</a>
   <li><a href="\#reading-books">How to read the books</a>
   <li><a href="\#searching">How to search for particular words</a>
@@ -209,22 +200,27 @@
 }
 
+_textnextbutton_ {Click on the arrow to go to the next section ...}
+_textprevbutton_ {... or back to the previous section}
+
+_httpicondtchdemo_ {_httpimg_/edtchof.gif}
+_httpicondtchdemo_ [l=mi] {_httpimg_/medtchof.gif}
+
+_httpiconeexpdemo_ {_httpimg_/eexpcof.gif}
+_httpiconeexpdemo_ [l=mi] {_httpimg_/meexpcof.gif}
+
+_httpiconealltdemo_ {_httpimg_/ealltof.gif}
+_httpiconealltdemo_ [l=mi] {_httpimg_/mealltof.gif}
+
 _textexplainbuttons_ {
 <p>
 <table cellspacing="0" cellpadding="2" border="0">
-<tr><td><img src="_httpimg_/smtext.gif" border="0" width=23 height=15"></td>
-<td>_texticonsmalltext_</td></tr>
-<tr><td><img src="_httpimg_/clsdfldr.gif" border="0" width=23 height=15"></td>
-<td>_texticonclosedfolder_</td></tr>
-<tr><td><img src="_httpimg_/more.gif" width="30" height="16"></td>
-<td>Click on the arrow to go to the next section ...</td></tr>
-<tr><td><img src="_httpimg_/less.gif" width="30" height="16"></td>
-<td>... or back to the previous section</td></tr>
-<tr><td><img src="_httpimg_/edtchof.gif" width="_edtchwidth_" height="_edtchheight_"></td>
-<td valign="center">_texticondetach_</td></tr>
-<tr><td><img src="_httpimg_/eexpcof.gif" width="_eexpcwidth_" height="_eexpcheight_"></td>
-<td valign="center">_texticonexpandtoc_</td></tr>
-<tr><td><img src="_httpimg_/ealltof.gif" width="_ealltwidth_" height="_ealltheight_"></td>
-<td valign="center">_texticonexpandtext_</td></tr>
-
+<tr><td><img src="_httpimg_/smtext.gif" border="0"></td><td>_document:texticonsmalltext_</td></tr>
+<tr><td><img src="_httpimg_/clsdfldr.gif" border="0"></td><td>_document:texticonclosedfolder_</td></tr>
+<tr><td><img src="_httpimg_/more.gif"></td><td>_textnextbutton_</td></tr>
+<tr><td><img src="_httpimg_/less.gif"></td><td>_textprevbutton_</td></tr>
+<tr><td><img src="_httpicondtchdemo_"></td><td valign="center">_document:texticondetach_</td></tr>
+<tr><td><img src="_httpiconeexpdemo_"></td><td valign="center">_document:texticonexpandtoc_</td></tr>
+<tr><td><img src="_httpiconealltdemo_"></td><td valign="center">_document:texticonexpandtext_</td></tr>
+<tr><td><img src="_document:httpiconehlof_"></td><td valign="center">_document:texticonhighlight_</td></tr>
 </table>
 }
@@ -302,21 +298,5 @@
 <a name=other-options><a name=scope-of-queries>
 _iconblankbar_<br>
-
-<h3 align=left>Scope of queries</h3>
-
-<p>
-You can choose the "granularity" at which your search is done, that
-is, the size of the text against which the query is matched.
-You can choose <i>title</i> or
-<i>chapter</i>.
-
-<p>Regardless of how you search, the results are always displayed in terms of a
-complete book, opened at the appropriate place.
-
-<p>
-<a name=stemming>
-_iconblankbar_<br>
-
-
+_texthelpscope_
 <h3 align=left>Case sensitivity and stemming</h3>
 
@@ -338,4 +318,27 @@
 }
 
+_textnumbrowseoptions_ {<p>There _If_("_numbrowseoptions_" == "1",is 1 way,are _numbrowseoptions_ ways) to 
+find information in this collection:}
+
+_textnumbrowseoptions_ [l=mi] {<p>E _numbrowseoptions_ ng&auml; huarahi hei rapu k&ouml;rero i te kohikohinga niupepa}
+
+_textsimplehelpheading_ {How to find information}
+
+_texthelpscope_ {
+<h3 align=left>Scope of queries</h3>
+
+<p>
+You can choose the "granularity" at which your search is done, that
+is, the size of the text against which the query is matched.
+You can choose <i>title</i> or
+<i>chapter</i>.
+
+<p>Regardless of how you search, the results are always displayed in terms of a
+complete book, opened at the appropriate place.
+
+<p>
+<a name=stemming>
+_iconblankbar_<br>
+}
 
 
@@ -366,6 +369,6 @@
   whai mai &euml;nei k&ouml;kiri kia rapu ai i (t)&euml;tehi kupu:<p>	
 
-  <ol><li>K&ouml;whiritia ko ng&auml; niupepa, ko ng&auml; kupu whakataki r&auml;nei, ko
-          aua mea e rua r&auml;nei
+  <ol><li>K&ouml;whiritia ko ng&auml; niupepa, ko ng&auml; kupu whakataki r&auml;nei, 
+	ko ng&auml; r&auml;popoto reo P&auml;keh&auml;, ko aua mea e toru r&auml;nei
       <li>K&ouml;whiritia ko &euml;tehi o ng&auml; kupu rapu, ko te katoa r&auml;nei o ng&auml;
           kupu rapu
@@ -427,19 +430,5 @@
 _iconblankbar_<br>
 
-<h3 align=left>Te wh&auml;nui o te rapu</h3>
-
-<p>
-You can choose the "granularity" at which your search is done, that
-is, the size of the text against which the query is matched.
-You can choose <i>title</i> or
-<i>chapter</i>.
-
-<p>Regardless of how you search, the results are always displayed in terms of a
-complete book, opened at the appropriate place.
-
-<p>
-<a name=stemming>
-_iconblankbar_<br>
-
+_texthelpscope_
 
 <h3 align=left>Ng&auml; p&uuml; matua, p&uuml; iti me ng&auml; k&uuml;muri hoki</h3>
@@ -468,4 +457,6 @@
 }
 
-
-
+_textsimplehelpheading_ [l=mi] {Ng&auml; huarahi hei rapu k&ouml;rero}
+
+_textnextbutton_ [l=mi] {Haere whakamua}
+_textprevbutton_ [l=mi] {Haere whakamuri}
Index: /trunk/gsdl/macros/home.dm
===================================================================
--- /trunk/gsdl/macros/home.dm	(revision 643)
+++ /trunk/gsdl/macros/home.dm	(revision 644)
@@ -1,4 +1,6 @@
 package home
 
+_httpmusiclibrary_ {http://www.nzdl.org/cgi-bin/gw?c=meldex&a=page&p=coltitle}
+_httpchineselibrary_ {_gwcgi_?a=p&p=about&c=chinese&l=zh&nw=u}
 
 #######################################################################
@@ -8,9 +10,55 @@
 # the _javalinks_ macros are the flashy image links at the top right of
 # the page. this is overridden here as we don't want 'home' 
-# or 'about' links on this page
+# links on this page
 
 _javalinks_ {}
 _javalinks_ [v=1] {}
 
+
+
+#######################################################################
+# icons
+#######################################################################
+
+_iconnzdl_ {<img src="_httpiconnzdl_" width=_widthnzdl_ height=_heightnzdl_>}
+_icongbull_ {<img src="_httpicongbull_">}
+_iconpdf_ {<img src="_httpiconpdf_">}
+_iconselectcollection_ {<img src="_httpiconselcolgr_" width=_widthselcolgr_ height=_heightselcolgr_>}
+_iconorvisit_ {<img src="_httpiconorvisgr_" width=_widthorvisgr_ height=_heightorvisgr_>}
+_iconmusiclibrary_ {<img src="_httpicontmusic_" width=_widthtmusic_ height=_heighttmusic_ border=0>}
+_iconchineselibrary_ {<img src="_httpicontchin_" width=_widthtchin_ height=_heighttchin_ border=0>}
+
+#######################################################################
+# http macros 
+#
+# These contain the url without any quotes
+#######################################################################
+
+#_httpiconnzdl_ {_httpimg_/nzdl.gif}
+#_widthnzdl_ {400}
+#_heightnzdl_ {112}
+_httpiconnzdl_ {_httpimg_/nzdl2br.gif}
+_widthnzdl_ {457}
+_heightnzdl_ {181}
+
+_httpicongbull_ {_httpimg_/gbull.gif}
+
+_httpiconpdf_ {_httpimg_/pdf.gif}
+
+_httpiconselcolgr_ {_httpimg_/selcolgr.gif}
+_widthselcolgr_ {537}
+_heightselcolgr_ {17}
+
+_httpiconorvisgr_ {_httpimg_/orvisgr.gif}
+_widthorvisgr_ {537}
+_heightorvisgr_ {17}
+
+_httpicontmusic_ {_httpimg_/tmusic.gif}
+_widthtmusic_ {120}
+_heighttmusic_ {17}
+
+_httpicontchin_ {_httpimg_/tchin.gif}
+_widthtchin_ {87}
+_heighttchin_ {17}
 
 #######################################################################
@@ -19,11 +67,48 @@
 
 _pagetitle_ {Greenstone Digital Library}
-_imagethispage_ {_imagegreenstone_}
+_imagethispage_ {<a href="_httpgreenstone_">_imagegreenstone_</a>}
+_imagecollection_ {_iconnzdl_}
 
 _content_ {
-_iconblankbar_<br>
+<center>_iconselectcollection_</center><br>
 _homeextra_
-_iconblankbar_<br>
-<a href="_httppagestatus_">Status page</a>
+<center><table width=_pagewidth_>
+<tr><td>_iconorvisit_
+</td></tr>
+<tr><td><a href="_httpmusiclibrary_">_iconmusiclibrary_</a>
+</td></tr>
+</td></tr>
+<tr><td><a href="_httpchineselibrary_">_iconchineselibrary_</a>
+</td></tr>
+<tr><td>_iconblankbar_
+</td></tr>
+</table>
+
+<table>
+<tr valign=top><td>
+
+<table border=0 cellpadding=5>
+<tr valign=top><td rowspan=10 width=32> </td>
+<tr valign=top><td>_icongbull_</td><td><a href="_httppagestatus_">_textstatuspage_</a></td></tr>
+<tr valign=top><td>_icongbull_</td><td><a href="mailto:_mailaddr_">_textfb_</a></td></tr>
+<tr valign=top><td>_icongbull_</td><td><a href="_httppagex_(people)">_textpeople_</a><br></td></tr>
+<tr valign=top><td>_icongbull_</td><td><a href="_httpprefix_/html/pub.htm">_textpub_</a><br></td></tr>
+<tr valign=top><td>_icongbull_</td><td><a href="_httppagex_(rw)">_textrw_</a><br></td></tr>
+<tr valign=top><td>_icongbull_</td><td><a href="_httppagex_(technology)">_texttec_</a><br></td></tr>
+<tr valign=top><td>_iconpdf_</td><td><a href="http://www.nzdl.org/publications/NZDLtext.pdf">_textinfosheet_</a></td></tr>
+<tr valign=top><td>_iconpdf_</td><td><a href="http://www.nzdl.org/publications/NZDLpictures.pdf">_textscreenshots_</a></td></tr>
+<tr valign=top><td>_iconpdf_</td><td><a href="http://www.nzdl.org/publications/Niupepa.pdf">_textnpepainfosheet_</a></td></tr>
+
+</table>
+
+</td>
+<td>
+
+<table border=0 cellpadding=5>
+<tr><td>
+<h2>_textprojhead_</h2>
+_textprojinfo_
+</td></tr></table>
+</td></tr></table>
 }
 
@@ -37,3 +122,58 @@
 _ago_ {days ago.}
 
+_textstatuspage_ {Admin/Status page}
+_textpeople_ {People}
+_textfb_ {Feedback}
+_textpub_ {Publications}
+_texttec_ {Technology}
+_textrw_ {Related Work}
+_textinfosheet_ {Info Sheet}
+_textscreenshots_ {Screen Shots}
+_textnpepainfosheet_ {Niupepa Info Sheet}
 
+_textprojhead_ {The New Zealand Digital Library Project}
+
+_textprojinfo_ {
+<h3>The NZDL system</h3>
+
+<p> The New Zealand Digital Library system comprises several demonstration
+collections -- computer science technical reports and bibliographies, literary
+works, humanitarian and development information, magazines -- and makes them
+available over the Web through full-text interfaces.  Behind the query
+interface lies a huge collection providing gigabytes of information.  We hope
+you find what you want, or at least something intriguing!
+
+<h3>The Greenstone software</h3>
+
+<p> The Greenstone Digital Library software provides a new way of organizing
+information and making it available over the Internet.  A <i>collection</i> of
+information comprises several (typically several thousand, or even several
+million) <i>documents</i>, which share a uniform searching and browsing
+interface.  The collections in a library are organized in a different
+way--though they share a strong family resemblance.  Although primarily
+designed for access over the Web, Greenstone collections can be made available,
+in precisely the same form, on CD-ROM for standalone PCs.  Greenstone is
+open-source software, available under the terms of the Gnu public linense.
+ 
+<h3>The research</h3>
+
+<p> The goal of our research program is to explore the potential of
+internet-based digital libraries.  Our vision is to develop systems that
+automatically impose structure on anarchic, uncatalogued, distributed
+repositories of information, thereby providing information consumers with
+effective tools to locate what they need and to peruse it conveniently and
+comfortably.  Our research objectives are to
+
+<ul>
+  <li> develop technology for creating and automatically
+      maintaining collections;
+  <li> monitor usage to study library users' needs;
+  <li> look at novel interfaces that cater to a wide spectrum of users;
+  <li> find ways to abstract layout and bibliographic information
+      from document files;
+  <li> use this information to enhance presentation and for
+      bibliometric research;
+  <li> assess potential subject areas for public-domain collections;
+  <li> survey and critique other digital library projects.
+</ul>
+}
Index: /trunk/gsdl/macros/pref.dm
===================================================================
--- /trunk/gsdl/macros/pref.dm	(revision 643)
+++ /trunk/gsdl/macros/pref.dm	(revision 644)
@@ -160,5 +160,5 @@
 <select name="l" onChange="updatel();">
   <option value="en"_If_("_cgiargl_",, selected)_If_("_cgiargl_" eq "en", selected)>English
-  <option value="mi"_If_("_cgiargl_" eq "mi", selected)>Maori
+  <option value="mi"_If_("_cgiargl_" eq "mi", selected)>M&auml;ori
   <option value="zh"_If_("_cgiargl_" eq "zh", selected)>Chinese
 </select>
@@ -177,6 +177,6 @@
 _textformat_
 <select name="v" onChange="updatev();">
-  <option value="0"_If_("_cgiargv_" eq "0", selected)>Graphical
-  <option value="1"_If_("_cgiargv_" eq "1", selected)>Textual
+  <option value="0"_If_("_cgiargv_" eq "0", selected)>_textgraphical_
+  <option value="1"_If_("_cgiargv_" eq "1", selected)>_texttextual_
 </select>
 }
@@ -250,4 +250,7 @@
 _textsimplemode_ {simple query mode}
 _textadvancedmode_ {advanced query mode (allows boolean searching using !, &, |, and parenthesis)}
+_textgraphical_ {Graphical}
+_texttextual_ {Textual}
+
 
 #######################################################################
@@ -261,8 +264,14 @@
 _textnostem_ [l=mi] { me tika te k&uuml;muri}
 _textprefop_ [l=mi] {Whakahokia mai te _maxdocoption_ kupu, &auml;, kia _hitsperpageoption_ kupu ki ia wh&auml;rangi.}
-
-
-
-
-
-
+_textlanguage_ [l=mi] {Reo: }
+_textencoding_ [l=mi] {Whakatakotoranga p&uuml;: }
+_textformat_ [l=mi] {Whakatakotoranga wh&auml;rangi: }
+_textsimplemode_ [l=mi] {te rapu wh&auml;iti}
+_textadvancedmode_ [l=mi] {te rapu wh&auml;nui (ka taea te whakamahia ng&auml; p&uuml; boolean, 
+p&euml;r&auml; i te !, &, |, me te "()" hoki)}
+_textgraphical_ [l=mi] {Whakaahua}
+_texttextual_ [l=mi] {K&auml;ore he whakaahua}
+
+
+
+
Index: /trunk/gsdl/macros/query.dm
===================================================================
--- /trunk/gsdl/macros/query.dm	(revision 643)
+++ /trunk/gsdl/macros/query.dm	(revision 644)
@@ -160,5 +160,5 @@
 _texticonthispage_ [l=mi] {rapu}
 _textsome_ [l=mi] {&euml;tehi}
-_textall_ [l=mi] {te katoa}
+_textall_ [l=mi] {_If_(_cgiargb_,te boolean,katoa)}
 _textbeginsearch_ [l=mi] {Rapua}
 _textfreqmsg1_ [l=mi] {Kia hia ng&auml; kupu: }
@@ -167,5 +167,9 @@
 _text1doc_ [l=mi] {1 te pukapuka e p&auml; ana ki &auml;u kupu rapu.}
 _textlotsdocs_ [l=mi] {ng&auml; pukapuka e p&auml; ana ki &auml;u kupu rapu.}
-
+_textmatches_ [l=mi] {Kitenga }
 _textstemon_ [l=mi] { (hei aha te k&uuml;muri)}
 
+_textsimplesearch_ [l=mi] {Tirohia ki _If_(_hselection_, _hselection_)_If_(_jselection_,_textjselect_)_If_(_nselection_, in _nselection_ language) m&ouml; _querytypeselection_ o ng&auml; kupu}
+
+_textadvancedsearch_ [l=mi] {Tirohia ki_If_(_hselection_, _hselection_)_If_(_jselection_,_textjselect_)_If_(_nselection_, in _nselection_ language) 
+m&ouml; _querytypeselection_ o ng&auml; kupu}